import random

HEROS = "heros"
CAPITAINE = "capitaine"
SOLDAT = "soldat"
TRAITRE = "traitre"
MAUDIT = "maudit"
MAGE = "mage"

LOUP = "loup"
SERPENT = "serpent"
CHEVAL = "cheval"
DRAGON = "dragon"
SANGLIER = "sanglier"
AIGLE = "aigle"

DE_BLANC = [HEROS, CAPITAINE, SOLDAT, TRAITRE, MAUDIT, MAGE]
DE_NOIR = [LOUP, SERPENT, CHEVAL, DRAGON, SANGLIER, AIGLE]


def lancer_des():
    """
    TODO
    Cette fonction doit renvoyer, sous la forme d'une liste,
    une combinaison de 7 faces de dé tirées aléatoirement.
    """

    
def evaluer(combinaison):
    """
    Cette fonction doit renvoyer la valeur d'une combinaison de dés.
    Elle prend en paramètre une liste des faces des dés, et
    renvoie la valeur de cette combinaison.
    """


def verification_decomposition_valide(decomposition):
    """
    Paramètre : un couple de 2 listes de dés correspondant
    à une partition de l'ensemble des dés de départ.
    Retour : vrai si et seulement si les valeurs des 2 listes sont égales.
    """

    
def resoudre(combinaison_restante, decomposition = None):
    if decomposition is None:
        decomposition = ([], [])
    armee1 = decomposition[0]
    armee2 = decomposition[1]

    if combinaison_restante == []:
        if verification_decomposition_valide(decomposition):
            return decomposition
        else:
            return None
    else:
        for face in combinaison_restante:
            copie_combinaison = list(combinaison_restante)
            copie_combinaison.remove(face)
            #cas1 : on met face dans la liste 1
            copie_armee1 = list(armee1)
            copie_armee2 = list(armee2)
            copie_armee1.append(face)
            solution = resoudre(copie_combinaison, (copie_armee1, armee2))
            if solution is not None:
                return solution
            copie_armee2.append(face)
            solution = resoudre(copie_combinaison, (armee1, copie_armee2))
            if solution is not None:
                return solution
        return None
    

##############################################################
###                  Quelques cas de test                  ###
##############################################################
def comparer_couples(couple1, couple2):
    """
    Cette fonction détermine si les couples de liste passés
    en paramètres sont équivalents. 2 couples sont équivalents
    s'ils sont constitués de 2 listes semblables. On considère
    que 2 listes sont semblables si elles contiennent les mêmes
    éléments, sans tenir compte de l'ordre.
    """

ex1 = [HEROS, HEROS, HEROS, CAPITAINE, CAPITAINE, CAPITAINE, SOLDAT]
ex2 = [CAPITAINE, CAPITAINE, SOLDAT, SOLDAT, HEROS, HEROS, TRAITRE]
ex3 = [CAPITAINE, CAPITAINE, SOLDAT, SOLDAT, SOLDAT, HEROS, MAGE]


defi1 = [HEROS, HEROS, HEROS, CAPITAINE, SOLDAT, SOLDAT, SOLDAT]
defi4 = [HEROS, HEROS, HEROS, HEROS, SOLDAT, TRAITRE, MAUDIT]
defi5 = [SOLDAT, SOLDAT, SOLDAT, SOLDAT, SOLDAT, SOLDAT, MAGE]
defi10 = [HEROS, HEROS, CAPITAINE, TRAITRE, TRAITRE, TRAITRE, MAGE]
defi15 = [HEROS, SOLDAT, TRAITRE, TRAITRE, MAGE, MAGE, MAGE]
defi16 = [HEROS, HEROS, HEROS, CAPITAINE,SOLDAT, SOLDAT, MAGE, LOUP]
defi19 = [HEROS, MAUDIT, MAUDIT, MAUDIT, SOLDAT, SOLDAT, MAGE, SERPENT]
defi22 = [HEROS, CAPITAINE, CAPITAINE, CAPITAINE, SOLDAT, SOLDAT, MAGE, CHEVAL]
defi25 = [SOLDAT, SOLDAT, SOLDAT, MAUDIT, MAUDIT, MAUDIT, MAGE, DRAGON]


def verification_evaluer():
    c1 = [HEROS, CAPITAINE, CAPITAINE, SOLDAT]
    assert evaluer(c1) == 8, "c1"
    c2 = [HEROS, HEROS, CAPITAINE]
    assert evaluer(c2) == 8, "c2"
    c3 = [CAPITAINE, CAPITAINE, SOLDAT]
    assert evaluer(c3) == 5, "c3"
    c4 = [HEROS, HEROS, TRAITRE, SOLDAT]
    assert evaluer(c4) == 5, "c4"
    c5 = [CAPITAINE, CAPITAINE, SOLDAT, SOLDAT]
    assert evaluer(c5) == 6, "c5"
    c6 = [HEROS, SOLDAT, MAGE]
    assert evaluer(c6) == 6, "c6"


def verification_resoudre():
    solution = resoudre(ex1)
    armee1 = [HEROS, HEROS, CAPITAINE]
    armee2 = [HEROS, CAPITAINE, CAPITAINE, SOLDAT]
    assert comparer_couples(solution, (armee1, armee2))

    solution = resoudre(ex2)
    armee1 = [CAPITAINE, CAPITAINE, SOLDAT]
    armee2 = [SOLDAT, HEROS, HEROS, TRAITRE]
    assert comparer_couples(solution, (armee1, armee2))

    solution = resoudre(ex3)
    armee1 = [CAPITAINE, CAPITAINE, SOLDAT, SOLDAT]
    armee2 = [SOLDAT, HEROS, MAGE]
    assert comparer_couples(solution, (armee1, armee2))

    solution = resoudre(defi1)
    armee1 = [HEROS, HEROS, SOLDAT]
    armee2 = [HEROS, CAPITAINE, SOLDAT, SOLDAT]
    assert comparer_couples(solution, (armee1, armee2))

    solution = resoudre(defi4)
    armee1 = [HEROS, HEROS, MAUDIT]
    armee2 = [HEROS, HEROS, SOLDAT, TRAITRE]
    assert comparer_couples(solution, (armee1, armee2))

    solution = resoudre(defi5)
    armee1 = [SOLDAT, SOLDAT, MAGE]
    armee2 = [SOLDAT, SOLDAT, SOLDAT, SOLDAT]
    assert comparer_couples(solution, (armee1, armee2))
    
    solution = resoudre(defi10)
    armee1 = [CAPITAINE, MAGE]
    armee2 = [HEROS, HEROS, TRAITRE, TRAITRE, TRAITRE]
    assert comparer_couples(solution, (armee1, armee2))

    solution = resoudre(defi15)
    armee1 = [HEROS, SOLDAT, MAGE]
    armee2 = [TRAITRE, TRAITRE, MAGE, MAGE]
    assert comparer_couples(solution, (armee1, armee2))
